<?php 

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\MAN\Utilities;
use Teknisa\MAN\Services;

class RelAliqProd {
    const ID_LISTAGEM_EST = 'E',
          ID_LISTAGEM_COM  = 'C',
          ID_LISTAGEM_ARV  = 'A';
          
    const dataSourceNameDefault = "ger01901r_relAliqProd";
    
    protected $utilService,
              $relAliqProd;
    
    public function __construct(Utilities\Util $utilService, $relAliqProd) {
        $this->utilService = $utilService;
        $this->relAliqProd = $relAliqProd;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response ) {
        $conditions = $this->utilService->getParamsAsArray($request);
        
        if (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'I'){
           if (empty($conditions['CDARVPRODF'])){
                $conditions['CDARVPRODF'] = $conditions['CDARVPRODI'];
           }
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['PRODNIV'] = null;
        }elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'D') {
           $conditions['PRODNIV'] = str_replace('%', '', str_replace('.', '', $conditions['PRODNIV'])).'%';
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
        }
        elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'L'){
           $conditions['CDPRODLIST'] = implode('_', $conditions['CDPRODUTO']);
           $conditions['TCDPRODUTO'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        }
        else{
           $conditions['TCDPRODUTO'] = 'T';
           $conditions['CDPRODLIST'] = null;
           $conditions['CDARVPRODF'] = null;
           $conditions['CDARVPRODI'] = null;
           $conditions['PRODNIV'] = null;
        }
        
        if($conditions['IDTIPOLISTAGEM'] === self::ID_LISTAGEM_ARV) {
            $produtosResult = $this->relAliqProd->getAliqProdutos($conditions);
        }  else if($conditions['IDTIPOLISTAGEM'] === self::ID_LISTAGEM_EST) {
            $produtosResult = $this->relAliqProd->getAliqProdutosEst($conditions);
        } else if($conditions['IDTIPOLISTAGEM'] === self::ID_LISTAGEM_COM) {
            $produtosResult = $this->relAliqProd->getAliqProdutosCom($conditions);
        }
        
        $response->addDataSet( new DataSet(self::dataSourceNameDefault, $produtosResult));
    }
    
}
